#ifndef SBK_KDateValidatorWrapper_H
#define SBK_KDateValidatorWrapper_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <kdatevalidator.h>

namespace PySide { class DynamicQMetaObject; }

class KDateValidatorWrapper : public KDateValidator
{
public:
    KDateValidatorWrapper(const KDateValidatorWrapper &) = delete;
    KDateValidatorWrapper& operator=(const KDateValidatorWrapper &) = delete;
    KDateValidatorWrapper(KDateValidatorWrapper &&) = delete;
    KDateValidatorWrapper& operator=(KDateValidatorWrapper &&) = delete;

    KDateValidatorWrapper(::QObject * parent = nullptr);
    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    void fixup(::QString & input) const override;
    void timerEvent(::QTimerEvent * event) override;
    ::QValidator::State validate(::QString & text, int & e) const override;
    ~KDateValidatorWrapper() override;

    const ::QMetaObject * metaObject() const override;
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[9] = {false, false, false, false, false, false, false, false, false};
};

#endif // SBK_KDateValidatorWrapper_H

